明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2477|回复: 1

一个测量立面图点标高的程序。

[复制链接]
发表于 2011-12-1 11:33:08 | 显示全部楼层 |阅读模式
本帖最后由 millermin 于 2011-12-1 11:35 编辑

贡献一个自编的求点标高的程序。基线可以是水平线,即普通的标高问题。也可以是标高有变化的曲线,比如桥面上的构筑物,或者路面的围墙挡土墙等基线不平的情况。欢迎指正。自己觉得可以用,但构思不算巧妙,算是笨方法。


(defun c:test()
  (vl-load-com)
  (setq acadobject (vlax-get-acad-object))
  (setq acaddocument (vla-get-activedocument acadobject))
  (setq mspace (vla-get-modelspace acaddocument))
  
  (setq bl (car (entsel "\n CHOOSE a BASE LINE:")))
  (setq blv (vlax-ename->vla-object bl)
        blst (vlax-curve-getstartpoint blv)
        blend (vlax-curve-getendpoint blv))
  (setq blstx (car blst))  
  (setq blendx (car blend))
  (setq blsty (cadr blst))
  (setq blendy (cadr blend))  
   
   (if (> blstx blendx)
        (progn
        (setq x0 blstx)        
        (setq blstx blendx)
        (setq blendx x0)
        )
    )
  (while (= "")
     (setq tp (getpoint "\n CHOOSE A POINT TO CHECK LEVEL:"))      
       (if (< blstx (car tp) blendx)   
          (progn
             (if (= blsty blendy)
               (setq hei (- (cadr tp) blendy))
               (progn  
               (setq tpinser(distpoint tp blv))
               (setq hei(- (cadr tp) (cadr tpinser)))
                )
              )
                (print (strcat "THIS POINT LEVEL IS:"  "-------------" "[ " (rtos hei) " ]"))
                (prin1)
              )
          )  
       (if (or (> blstx (car tp)) (< blendx (car tp)))   
          (progn
             (if (= blsty blendy)
               (progn
                  (setq hei (- (cadr tp) blendy))
                  (print (strcat "THIS POINT LEVEL IS:"  "-------------" "[  " (rtos hei) "  ]"))
                  (prin1)
                )
                (progn  
                  (print (strcat"---------------------------------------------" "THIS POINT IS INVALID "  ))
                  (prin1)
                 )
               )  ; end if
             )   ; end progn
          )     ;end if
    )  ; end while
)

(defun distpoint(sp vlacurve)
         (setq sp1 (list (car sp)  (- (cadr sp) 100000) 0.0))
         (setq sp2 (list (car sp)  (+ (cadr sp) 100000) 0.0))
         (setq downv (vlax-make-safearray vlax-vbdouble'(0 . 2)))
         (vlax-safearray-fill downv sp1)
         (setq upv (vlax-make-safearray vlax-vbdouble'(0 . 2)))
         (vlax-safearray-fill upv sp2)
         
         (setq addlinev (vla-addline mspace upv downv))
         (setq crossv (vla-IntersectWith vlacurve addlinev acExtendNone))
              
         (setq addline (vlax-vla-object->ename addlinev))
         (command "erase" addline "")
         (setq cross (vlax-safearray->list (vlax-variant-value crossv)))
    )











发表于 2013-6-16 09:23:55 | 显示全部楼层
能增加图面标注 的功能就更好
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2025-4-6 14:31 , Processed in 0.412781 second(s), 30 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表